# -*- encoding: utf-8 -*-
# --------------------------------------------------------------------------------
# Project:               TransALM
# Copyright:           © by the authors since 2010  All rights reserved.
# --------------------------------------------------------------------------------
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
# --------------------------------------------------------------------------------
# Created:               Jun 16, 2010 10:34:16 PM by telgabsi
# Last modified:         2010-06-25 11:16:29 AM
#
# Last Author:           $LastChangedBy$
# Last Checkin:          $LastChangedDate$
# Checked out Version:   $LastChangedRevision$
# HeadURL:               $HeadURL$
# --------------------------------------------------------------------------------
from osv import fields
from osv import osv

class asset(osv.osv):
    '''
    An asset in a repository is implicitely versionable
    '''
    _name = 'software.repository.asset'
    _descripton = 'The versionable asset in a repository'
    _rec_name = 'name'
    _columns = {
                'name':fields.char('Asset', size = 256, required = True),
                'version':fields.char('Version', size = 128, required = True),
                #TODO 'preversion': fields.many2one('software.repository.asset', readonly=True, string = 'Previous Version'),
                #TODO Semantic Version extract 'parent': fields.one2one('software.repository.asset', readonly=True, string = 'Drived from', domain = [('prerevision', ' = ', 'None')]),
                'mimetype': fields.char('MimeType', requierd = True),
                'path':fields.char('Path', required = True, help = 'The relative path within the repository'),
                'repository_id': fields.many2one('software.repository','Repository',ondelete="cascade"),
    }
asset()

class baseline(osv.osv):
    '''
    A logical collection of assets in a repository at most one version of each asset
    '''
    _name = 'software.repository.baseline'
    _descripton = 'A base line in a repository'
    _columns = {
                'name':fields.char('Baseline', size = 256, required = True),
                'assets': fields.one2many('software.repository.asset', string = 'Assets')#TODO restrict to at most one version
    }
baseline()

class component(osv.osv):
    '''
    A software component as source assets
    '''
    _name = 'software.component'
    _descripton = 'A collection of assets to be managed as a unit'
    _columns = {
                'name':fields.char('Asset', size = 256, required = True),
                'assets':fields.one2many('software.repository.asset', string = 'Assets')
                }
component()
#TODO class component_baseline
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4
