# -*- encoding: utf-8 -*-
# --------------------------------------------------------------------------------
# Project:               TransALM
# Copyright:           © by the authors since 2010  All rights reserved.
# --------------------------------------------------------------------------------
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
# --------------------------------------------------------------------------------
# Created:               Jun 17, 2010 12:00:05 AM by telgabsi
# Last modified:         2010-06-25 10:54:43 AM
#
# Last Author:           $LastChangedBy$
# Last Checkin:          $LastChangedDate$
# Checked out Version:   $LastChangedRevision$
# HeadURL:               $HeadURL$
# --------------------------------------------------------------------------------
from osv import fields
from osv import osv

class repository(osv.osv):
    '''
    The model class Repository
    '''
    _name = 'software.repository'
    _description = 'Repository for configuration management'
    _rec_name = 'name'
    _columns = {
                'name':fields.char('URI', size = 77, required = True, translate = False),
                'branches': fields.one2many('software.repository.branch','repository_id','Branches'),
                'assets': fields.one2many('software.repository.asset','repository_id','Assets'),
    }

repository()

class branch(osv.osv):
    '''
    A branch inside a repository
    '''
    _name = 'software.repository.branch'
    _description = 'A repository branch'
    _rec_name = 'name'
    _columns = {
                'name' : fields.char('Name', size = 77, required = False, translate = False),
                'active':fields.boolean('Active', help = 'If False no checkins are allowed'),
                'repository_id': fields.many2one('software.repository','Repository',ondelete="cascade"),
                #'predecessor': fields.one2one('software.repository.branch', string = 'Predecessor')
    }

branch()


# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
