# -*- encoding: utf-8 -*-
# --------------------------------------------------------------------------------
# Project:               TransALM
# Copyright:           © by the authors since 2010  All rights reserved.
# --------------------------------------------------------------------------------
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
# --------------------------------------------------------------------------------
# Created:               Jun 17, 2010 12:04:18 AM by telgabsi
# Last modified:         Jun 17, 2010 12:04:18 AM
#
# Last Author:           $LastChangedBy$
# Last Checkin:          $LastChangedDate$
# Checked out Version:   $LastChangedRevision$
# HeadURL:               $HeadURL$
# --------------------------------------------------------------------------------

class VersionControlSystem:
    '''
    A wrapper for Bazaar
    '''
    def init_repository(self, repository_name):
        '''
        Initialises a repository and creates a trunk branch
        @param repository_name: The name of the repository (unique system wide)
        '''
        pass

    def branch_repository(self, repository, branch_new, branch_parent = 'trunk'):
        '''
        Crates a branch with name branch_new within the repository
        @param repository: The repository
        @param branch_parent: The branch to branch defaults to trunk which is initialized by default
        @param branch_new:The new branch to create 
        '''
        pass

    def create_baseline(self, baseline_name, component, excluded_assets = []):
        '''
        Create a base from the latest version of the assets in a component
        @param baseline_name: The name of the baseline to be created
        @param component: The component which assets are to be tagged @see: software_configuration.component
        @param excluded_assets: A list of assets to be excluded from the base line
        '''
        pass
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
