# -*- encoding: utf-8 -*-
# --------------------------------------------------------------------------------
# Project:               TransALM
# Copyright:           © by the authors since 2010  All rights reserved.
# --------------------------------------------------------------------------------
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
# --------------------------------------------------------------------------------
# Created:               Apr 4, 2010 by aegbe
# Last modified:         2010-07-05 07:17:52 PM
#
# Last Author:           $LastChangedBy$
# Last Checkin:          $LastChangedDate$
# Checked out Version:   $LastChangedRevision$
# HeadURL:               $HeadURL$
# ----------------------------------------------------------------------------------

from osv import fields, osv


class software_feature(osv.osv):
    _name = 'software.feature'
    _description = 'Features of software products'
    _rec_name = 'summary'
    _columns = {
        'cost': fields.integer('Cost'),
        'summary' : fields.char('Summary', size = 200, required = True),
        'details' : fields.text('Details'),
        #TODO many2many should be on the feature side
        'products': fields.many2many('product.product', 'software_feature_product_rel', 'software_feature_id', 'product_id', 'Products'),

    }
software_feature()

class product_product(osv.osv):
    _inherit = 'product.product'
    _name = 'product.product'
    _columns = {
        'features': fields.many2many('software.feature', 'software_feature_product_rel', 'product_id', 'software_feature_id', 'Features'),
    }
product_product()
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
